CombatWindow = class(Turbine.UI.Window)
function CombatWindow:Constructor()
    Turbine.UI.Window.Constructor(self);

    local width = Settings.CTWidth
    local height = Settings.CTHeight
    local x = Settings.CTX
    local y = Settings.CTY
    local cooldownTimer = 0
    self.combat = nil
    self.minutes = 0
    self.seconds = 0
    self.outSeconds = 0

    self:SetSize(width,height);
    self:SetPosition(x,y);
    self:SetZOrder(1);

    self:SetWantsKeyEvents(true)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    Updater:Subscribe(self)

    self.combatWindow = Turbine.UI.Label()
    self.combatWindow:SetParent(self)
    self.combatWindow:SetSize(width, 40)
    self.combatWindow:SetPosition(0, height - 40)
    self.combatWindow:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter)
    --1107296276
    --Turbine.UI.Lotro.Font.TrajanProBold36
    self.combatWindow:SetFont(Settings.CTFont)
    self.combatWindow:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.combatWindow:SetMouseVisible(false)
    self.combatWindow:SetText(self.minutes..":".."00")
    self.combatWindow:SetVisible(true)
    --self.combatWindow:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.combatWindow:SetMouseVisible(true)

    self.oldCombatWindowWindow = Turbine.UI.Window()
    self.oldCombatWindowWindow:SetParent(self)
    self.oldCombatWindowWindow:SetSize(width, height - 40)
    self.oldCombatWindowWindow:SetPosition(0, 0)
    self.oldCombatWindowWindow:SetOpacity(0.5)
    --self.oldCombatWindowWindow:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    self.oldCombatWindowWindow:SetVisible(true)

    self.oldCombatWindow = Turbine.UI.ListBox()
    self.oldCombatWindow:SetParent(self.oldCombatWindowWindow)
    self.oldCombatWindow:SetSize(width, height - 40)
    self.oldCombatWindow:SetPosition(0, 0)
    --self.oldCombatWindow:SetReverseFill(true)
    self.oldCombatWindow:SetVisible(true)

    self.scrollbar = Turbine.UI.Lotro.ScrollBar()
    self.scrollbar:SetParent(self)
    self.scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.scrollbar:SetSize(12,height - 40)
    --self.scrollbar:SetPosition(self.messageBox:GetLeft() + self.messageBox:GetWidth(),self.messageBox:GetTop())
    self.scrollbar:SetPosition(width - 12, 0)
    self.scrollbar:SetVisible(false)
    self.oldCombatWindow:SetVerticalScrollBar(self.scrollbar)

    self.oldCombatWindow:SetOpacity(0)   
    self.oldCombatWindowWindow:SetOpacity(0) 

    self.combatWindow.MouseEnter = function()
        self.oldCombatWindow:SetOpacity(1)
        self.oldCombatWindowWindow:SetOpacity(1)
    end

    self.combatWindow.MouseLeave = function()
        self.oldCombatWindow:SetOpacity(0)   
        self.oldCombatWindowWindow:SetOpacity(0) 
    end
  
    local moveBox = MoveBox(self, width, height, "Combat Timer")
    
    self.ToggleMove = function()
        moveBox:ToggleMove()
    end

    self.combat = Player:IsInCombat()

    --Player.InCombatChanged = function(sender, arg)
    self.CombatChanged = function()
        if Player:IsInCombat() then
            if not(self.combat) and not(self.seconds <= 3 and self.minutes == 0) and self.outSeconds > 3 then
                -- [[
                local item = Turbine.UI.Control()
                item:SetSize(width, 20)
                --item:SetBackColor(Turbine.UI.Color(0,0,0))
            
                item.oldCombat = Turbine.UI.Label()
                item.oldCombat:SetSize(width, 20)
                --self.label:SetPosition(0,0)
                item.oldCombat:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter)
                item.oldCombat:SetFont(Turbine.UI.Lotro.Font.TrajanPro19)
                item.oldCombat:SetFontStyle(Turbine.UI.FontStyle.Outline)
                item.oldCombat:SetMouseVisible(false)
                item.oldCombat:SetVisible(true)
                item.oldCombat:SetOutlineColor(Turbine.UI.Color(0,0,0))
                --item.oldCombat:SetBackColor(Turbine.UI.Color(0, 0, 0))
                item.oldCombat:SetText(MakeSaveString(self.minutes, self.seconds))
                item.oldCombat:SetParent(item)
              
                if self.oldCombatWindow:GetItemCount() > 3 then
                    local item = self.oldCombatWindow:GetItem(1)
                    self.oldCombatWindow:RemoveItemAt(1)
                    item:SetParent(nil)
                end
                self.oldCombatWindow:AddItem(item)
                --]]
                self.seconds = 0
                self.minutes = 0
            end 
            self.combat = true
            self.outSeconds = 0
        else

            self.combat = false
        end
    end
end

function CombatWindow:ExecuteUpdate(delta)
    if self.combat then
        self.seconds = self.seconds + delta
        if self.seconds >= 60 then
            self.seconds = 0
            self.minutes = self.minutes + 1
        end
        self.combatWindow:SetText(MakeString(self.minutes, math.floor(self.seconds)))

    else
        self.outSeconds = self.outSeconds + delta
    end
end

function MakeString(min, sec)
    if sec < 10 then
        return(min..":0".. sec)
    else 
        return(min..":".. sec)
    end
end

function MakeSaveString(min, sec)
    if sec < 10 then
        return(min..":0".. Round(sec, 1))
    else 
        return(min..":".. Round(sec, 1))
    end
end
