-- Load init.lua
import "PrimePlugins.RaidTools"

-- Don't touch this if you do not know why this is here
-- Rühr es nicht an wann du das nicht versteht warum es da ist
if not(Turbine.Language.EnglishGB == Turbine.Engine.GetLanguage() or Turbine.Language.English == Turbine.Engine.GetLanguage()) then 
    ChatOutput("Set your client to english")
    return
end

-- Create reloader
reload = Reloader()

-- Retrieve plugin version, (reload)data and settings
PluginVersion = plugin:GetVersion()
UpdateSettings() 
SetScale()
LoadData()
ReloadStateData = Turbine.PluginData.Load(Turbine.DataScope.Server, "PrimeReloadData") 

-- Setup player and party data
Player = Turbine.Gameplay.LocalPlayer.GetInstance();
PlayerName = Player:GetName()
Name = Player:GetName();
Party = Player:GetParty();
if Party ~= nil then
    GroupSize = Party:GetMemberCount()
else
    GroupSize = 1
end

-- Handle lootlock data
LootLocks = Turbine.PluginData.Load(Turbine.DataScope.Server, "PrimeLootLocks")
if LootLocks == nil then
    LootLocks = {}
end

--Build current party to not break the plugin
Group = {}
GroupIDToName = {}
SetGroup()
SetEffects()

-- Create the global upate handler
Updater = UpdateHandler()

-- Countdown window
countdownWindow = CountdownWindow()

-- Combat timer
if Settings.CTEnabled then combatTimer = CombatWindow() end

-- Alert, dnf tracker and effects
if Settings.AEnabled then messageWindow = AlertWindow() end 
if Settings.AEnabled then rezTracker = DNFTracker() end
if Settings.EEnabled then effectsWindow = EffectsWindow() end 

-- Skill & boss timers
if Settings.SEnabled then skillCounters = SkillCounters() end 
if Settings.SPEnabled then skillTimers = SkillTimers(0) end 
if Settings.SPEnabled then activeTimers = SkillTimers(1) end

-- Note Window
noteWindow = NoteWindow()

-- Leader & Log Window
if Settings.LWEnabled then leaderWindow = LeaderWindow() end
if Settings.LEnabled then logWindow = LogWindow() end 

-- Loot, Stat window & dungeon window
if Settings.LOEnabled then lootWindow = LootWindow() end
Statwindow = nil --Stats()
DungeonWindow = nil --DungeonLog()

-- Options button & reload windows
reloadWindow = ReloadWindow()
optionsButton = OptionsButton()
MasterOptions = nil

-- Skill window
skillWindow = SkillWindow()

-- Improved ready check windows
ReadyCheck = ReadyWindow()
RcWindow = ReadyCheckWindow()
RCButtonWindow = ReadyButtonWindow()
RButton = ReloadButton()

-- Sound player
Sounds = SoundPlayer()

-- Swap window
SwappyWarner = SwapWarner()

-- Instance Hanlder
InstanceController = InstanceHub()

-- Target Window
if Settings.TEnabled then 
    if GroupSize <= 3 or Settings.TOverride then
        Target = TargetWindow()
    else
        ChatOutput("Target window disabled due to group size! You can override this in the master options.")
    end
end

-- Garbage Collection handler
GCHandler = GarbageHandler()

-- Create buff windows from saved settings
HandleBuffWindows()

-- Set global event handlers
InitiateHandlers()

-- Handle reloading when notes and countdown exists
if ReloadStateData ~= nil then
    if ReloadStateData.Note ~= nil then
        if ReloadStateData.Note ~= "" then 
            noteWindow.noteWindow:SetText(ReloadStateData.Note)
            ChatOutput("<rgb=#004d00>Note window repopulated after restart, type /prime noteClear to clear the note window if this is needed.</rgb>")
        end
    end
    local cd = ReloadStateData.Countdown
    if ReloadStateData.Countdown ~= nil and cd > 0 then
        countdownWindow:Countdown(cd)
    end
end

-- Load the plugin manager options
import "PrimePlugins.RaidTools.Options"

-- Setup all group events
SetTriggers()

-- Initialize commands
SetCommands()

-- Create skill overlays from data
CreateSkillBarFromSave()

local greetingsMessage = Greetings[math.random(1, 188)]

-- Import test env
--import "PrimePlugins.RaidTools.TestFile"

-- Set the unload events
plugin.Unload = function() 
    SaveData()
    SaveLoot()
    SaveStats()
end

-- Set back to normal state
Settings.ReloadData = false

-- We have succesfully (re)loaded the plugin
if Settings.ReloadData then 
    ChatOutput("<rgb=#FF9900>"..plugin:GetName() .. " Version " .. PluginVersion .." reloaded.</rgb>") 
else
    ChatOutput("<rgb=#FF9900>"..plugin:GetName() .. " Version " .. PluginVersion .." loaded.</rgb>") 
end